﻿
$config = ".\config.txt"
   
if (Test-Path $config){
	$file = Get-Content "$config"
	$containsWord = $file | %{$_ -match "MEClauncher"}
	if ($containsWord -contains $true){
		$MEClauncher = Get-Content $config | Where-Object {$_ -like ‘*MEClauncher*’}
		$Regex = [Regex]::new("(?<=<)(.*)(?=>)")           
		$Match = $Regex.Match($MEClauncher)           
		if($Match.Success){
			$MEClauncher = $Match.Value
			if (([string]::IsNullOrWhiteSpace($MEClauncher)) -Or (-not(Test-Path $MEClauncher))){
				Write-Output "Path entered for MEC launcher is invalid"
				Start-Sleep -Seconds 5
				EXIT (1)
				}
			}
	}
	else{
		Write-Output "Please check the tag to enter the path for MEC launcher"
		Start-Sleep -Seconds 5
		EXIT (1)
	}
	
    $file = Get-Content "$config"
    $containsWord = $file | %{$_ -match "jazzInstallDir"}
	if ($containsWord -contains $true){

		$Regex = [Regex]::new("(?<=<)(.*)(?=>)")           
		$Match = $Regex.Match($jazzInstallDir)           
		if($Match.Success){
			$jazzInstallDir = $Match.Value
			if (([string]::IsNullOrWhiteSpace($jazzInstallDir)) -Or (-not(Test-Path $jazzInstallDir))){
             
				Write-Output "Path entered for JTS Directory is invalid"
				Start-Sleep -Seconds 5
				EXIT (1)
				}
			}
		}
	else{
		Write-Output "Please check the tag to enter the path for Jazz teams server Directory"
		Start-Sleep -Seconds 5
		EXIT (1)
	}	

	
	$containsWord = $file | %{$_ -match "reqifFile"}
	if ($containsWord -contains $true){
		$reqifFile = Get-Content $config | Where-Object {$_ -like ‘*reqifFile*’}
		$Regex = [Regex]::new("(?<=<)(.*)(?=>)")           
		$Match = $Regex.Match($reqifFile)           
		if($Match.Success){
			$reqifFile = $Match.Value
			if (([string]::IsNullOrWhiteSpace($reqifFile)) -Or (-not(Test-Path $reqifFile))){
				Write-Output "Path entered ReqIf File is invalid"
				Start-Sleep -Seconds 5
				EXIT (1)
				}
			}
		}
	else{
		Write-Output "Please check the tag to enter the path for ReqIf file"
		Start-Sleep -Seconds 5
		EXIT (1)
	}	
	
	$containsWord = $file | %{$_ -match "methodLibrary"}
	if ($containsWord -contains $true){
		$methodLibrary = Get-Content $config | Where-Object {$_ -like ‘*methodLibrary*’}
		$Regex = [Regex]::new("(?<=<)(.*)(?=>)")
		$Match = $Regex.Match($methodLibrary)
		if($Match.Success){
			$methodLibrary = $Match.Value
			if (([string]::IsNullOrWhiteSpace($methodLibrary)) ) {
				Write-Output "Please enter the path for Method Library"
				Start-Sleep -Seconds 5
				EXIT (1)
				}
			}
			elseif (-not(Test-Path $methodLibrary)){
				$replaceLibrary = Get-Content $config | Where-Object {$_ -like ‘*replaceLibrary*’}
				$Regex = [Regex]::new("(?<=<)(.*)(?=>)")
				$Match = $Regex.Match($replaceLibrary)
				if($Match.Success){
					$replaceLibrary = $Match.Value
					$containsWord = $replaceLibrary | %{$_ -match "true"}
					if ($containsWord -contains $true){
						Copy-Item -Path .\DefaultLibrary\ -Destination $methodLibrary 
					}
				}
				else {
					Write-Output "Please enter the path for Method Library"
					Start-Sleep -Seconds 5
					EXIT (1)
				}
			}
	}
	else{
		Write-Output "Please check the tag to enter the path for Method Library "
		Start-Sleep -Seconds 5
		EXIT (1)
	}







	$containsWord = $file | %{$_ -match "workspace"}
	if ($containsWord -contains $true){
		$workspace = Get-Content $config | Where-Object {$_ -like ‘*workspace*’}
		$Regex = [Regex]::new("(?<=<)(.*)(?=>)")           
		$Match = $Regex.Match($workspace)           
		if($Match.Success){
			$workspace = $Match.Value
			if (([string]::IsNullOrWhiteSpace($workspace))  -Or (-not(Test-Path $workspace))) {
				Write-Output "Path entered for Workspace is invalid"
				Start-Sleep -Seconds 5
				EXIT (1)
				}
			}
		}
	else{
		Write-Output "Please check the tag to enter the path for the workspace "
		Start-Sleep -Seconds 5
		EXIT (1)
	}	


	$containsWord = $file | %{$_ -match "publishTo"}
	if ($containsWord -contains $true){
		$publishTo = Get-Content $config | Where-Object {$_ -like ‘*publishTo*’}
		$Regex = [Regex]::new("(?<=<)(.*)(?=>)")           
		$Match = $Regex.Match($publishTo)           
		if($Match.Success){
			$publishTo = $Match.Value
			if (([string]::IsNullOrWhiteSpace($publishTo)) -Or (-not(Test-Path $publishTo))) {
				Write-Output "Path entered for saving published file is invalid"
				Start-Sleep -Seconds 5
				EXIT (1)
				}
			}
		}
	else{
		Write-Output "Please check the tag to enter the path for saving the published file "
		Start-Sleep -Seconds 5
		EXIT (1)
	}
	
	
	$containsWord = $file | %{$_ -match "configuration"}
	if ($containsWord -contains $true) {
		$configuration = Get-Content $config | Where-Object {$_ -like ‘*configuration*’}
		$Regex = [Regex]::new("(?<=<)(.*)(?=>)")          
		$Match = $Regex.Match($configuration)           
		if($Match.Success){
			$configuration = $Match.Value
			if ([string]::IsNullOrWhiteSpace($configuration)) {
				$DefaultConfiguration = Get-Content $config | Where-Object {$_ -like ‘*reqifFile*’}
				$Regex = [Regex]::new("(?<=<)(.*)(?=>)")
				$Match = $Regex.Match($DefaultConfiguration)
				if($Match.Success){
					$DefaultConfiguration = $Match.value
					$DefaultConfiguration = [System.IO.Path]::GetFileNameWithoutExtension($DefaultConfiguration)
					$configuration = $DefaultConfiguration 
				}
			}
		}
	}
	else {
		$DefaultConfiguration = Get-Content $config | Where-Object {$_ -like ‘*reqifFile*’}
		$Regex = [Regex]::new("(?<=<)(.*)(?=>)")
		$Match = $Regex.Match($DefaultConfiguration)           
		if($Match.Success){
			$DefaultConfiguration = $Match.value
			$DefaultConfiguration = [System.IO.Path]::GetFileNameWithoutExtension($DefaultConfiguration)
			$configuration = $DefaultConfiguration 
		}
	}
	






	& $MEClauncher -product com.ibm.rmc.rcp.ui.75.composer -rmcsilent import -rmcreqif $reqifFile -rmclibrary $methodLibrary -rmcmergeoption true -rmcsilent publish -rmclibrary $methodLibrary -data $workspace -rmcconfiguration $configuration -rmcoutput $publishTo | Out-Null

	
	Rename-Item $publishTo\rmcwebsite.war rmcwebsite.zip
	Expand-Archive -Path $publishTo\rmcwebsite.zip -DestinationPath $publishTo\rmcwebsite
	Rename-Item $publishTo\rmcwebsite rmcwebsite.war
	Copy-Item $publishTo\rmcwebsite.war $jazzInstallDir\server\liberty\servers\clm\dropins\
	
	
}
else {
	Write-Output "Config file not found"
	Start-Sleep -Seconds 5
	EXIT (1)
}





